/****************************************************************************
 *                                                                          *
 * File    : main.c                                                         *
 *                                                                          *
 * Purpose : Generic dialog based Win32 application.                        *
 *                                                                          *
 * History : Date      Reason                                               *
 *           00/00/00  Created                                              *
 *                                                                          *
 ****************************************************************************/

/* 
 * Either define WIN32_LEAN_AND_MEAN, or one or more of NOCRYPT,
 * NOSERVICE, NOMCX and NOIME, to decrease compile time (if you
 * don't need these defines -- see windows.h).
 */

#define WIN32_LEAN_AND_MEAN
/* #define NOCRYPT */
/* #define NOSERVICE */
/* #define NOMCX */
/* #define NOIME */

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <tchar.h>
#include "main.h"

#define NELEMS(a)  (sizeof(a) / sizeof((a)[0]))

/** Prototypes **************************************************************/

static INT_PTR CALLBACK MainDlgProc(HWND, UINT, WPARAM, LPARAM);

/** Global variables ********************************************************/

static HANDLE ghInstance;


int xmouse = 1;
int ymouse = 1;











//#include <graphics.h>
#include <math.h>
#include <stdlib.h>
//#include <dos.h>

typedef enum {false, true} boolean;

#define WBC 5

#define X 200
#define Y 200


#define SIZE 2.
#define ZROTATE 11.
#define YROTATE 40.
#define XROTATE 0.

#define M_PI 3.141592




double function(double x, double y)
{
	double f;
	f = hypot(x, y) / 35.;
	if( fabs(f) < 1.e-5) return (40. * M_PI);
	else return (40. * sin(f * M_PI) / f);
}


void rotate3d(double xr, double yr, double zr, double *px, double *py, double *pz)
{
  double x = *px, y = *py, z = *pz;
  double x1, y1, z1, x2, y2, z2, x3, y3, z3;

  x1 = x * cos(zr) - y * sin(zr);
  y1 = x * sin(zr) + y * cos(zr);
  z1 = z;

  x2 = x1 * cos(yr) - z1 * sin(yr);
  y2 = y1;
  z2 = x1 * sin(yr) + z1 * cos(yr);

  x3 = x2;
  y3 = y2 * cos(xr) - z2 * sin(xr);
  z3 = y2 * sin(xr) + z2 * cos(xr);

  *px = x3;
  *py = y3;
  *pz = z3;
}


int getmaxx()
{
	return 100;
}

int getmaxy()
{
	return 100;
}

void moveto(HDC hdc, int xx, int yy)
{
	POINT pt;
	MoveToEx(hdc, xx, yy, &pt);
}

void lineto(HDC hdc, int xx, int yy)
{
	LineTo(hdc, xx, yy);
}

void graph(HDC hdc, double y, double z, int *plotted)
{
  int xx, yy, xasp, yasp;

  xasp = 1;
  yasp = 1;
//  getaspectratio(&xasp, &yasp);
  xx = getmaxx() / 2 + (int) y;
  yy = getmaxy() / 2 - (int) (z * xasp / yasp);
  if(*plotted == false) moveto(hdc, xx, yy);
  else lineto(hdc, xx, yy);
  *plotted = true;
}


void fn_zero()
{
	if(xmouse == 0) xmouse = 1;
	if(ymouse == 0) ymouse = 1;
}


void fn_main(HDC hdc)
{
//  int graphdrive = DETECT, graphmode;
  int plotted = false;
  double x, y, z, x2, y2, z2;
  double zr, yr, xr;
  double rd, rx, ry;
  char c;
	int i;

//  initgraph(&graphdrive, &graphmode, "c:\\turboc3\\bgi");

  zr = ZROTATE * M_PI / 180.;
  yr = YROTATE * M_PI / 180.;
  xr = XROTATE * M_PI / 180.;

//int const size=600;

//union REGS i,o;
//i.x.ax=1;
//int86(0x33,&i,&o);

//rd = (double)(int)o;

  for(x = -115.; x <= 115.; x += 5.)
  {
	fn_zero();
    rx = rand()%xmouse;
    ry = rand()%ymouse;
    for(y = -115.; y <= 115.; y += 5.)
    {

      z = function(x, y);
      x2 = x * SIZE - 300 + rx;
      y2 = y * SIZE + 300 + ry;
      z2 = z * SIZE;
      rotate3d(xr, yr, zr, &x2, &y2, &z2);
      graph(hdc, y2, z2, &plotted);
    }
    plotted = false;
  }

//	if(kbhit()) {
//	return;
//	}

}













/****************************************************************************
 *                                                                          *
 * Function: WinMain                                                        *
 *                                                                          *
 * Purpose : Initialize the application.  Register a window class,          *
 *           create and display the main window and enter the               *
 *           message loop.                                                  *
 *                                                                          *
 * History : Date      Reason                                               *
 *           00/00/00  Created                                              *
 *                                                                          *
 ****************************************************************************/

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow)
{
    INITCOMMONCONTROLSEX icc;
    WNDCLASSEX wcx;

    ghInstance = hInstance;

    /* Initialize common controls. Also needed for MANIFEST's */
    /*
     * TODO: set the ICC_???_CLASSES that you need.
     */
    icc.dwSize = sizeof(icc);
    icc.dwICC = ICC_WIN95_CLASSES /*|ICC_COOL_CLASSES|ICC_DATE_CLASSES|ICC_PAGESCROLLER_CLASS|ICC_USEREX_CLASSES|... */;
    InitCommonControlsEx(&icc);

    /* Load Rich Edit control support */
    /*
     * TODO: uncomment one of the lines below, if you are using a Rich Edit control.
     */
    // LoadLibrary(_T("riched32.dll"));  // Rich Edit v1.0
    // LoadLibrary(_T("riched20.dll"));  // Rich Edit v2.0, v3.0

    /*
     * TODO: uncomment line below, if you are using the Network Address control (Windows Vista+).
     */
    // InitNetworkAddressControl();

    /* Get system dialog information */
    wcx.cbSize = sizeof(wcx);
    if (!GetClassInfoEx(NULL, MAKEINTRESOURCE(32770), &wcx))
        return 0;

    /* Add our own stuff */
    wcx.hInstance = hInstance;
    wcx.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDR_ICO_MAIN));
    wcx.lpszClassName = _T("SOMBREROClass");
    if (!RegisterClassEx(&wcx))
        return 0;

    /* The user interface is a modal dialog box */
    return DialogBox(hInstance, MAKEINTRESOURCE(DLG_MAIN), NULL, (DLGPROC)MainDlgProc);
}

/****************************************************************************
 *                                                                          *
 * Function: MainDlgProc                                                    *
 *                                                                          *
 * Purpose : Process messages for the Main dialog.                          *
 *                                                                          *
 * History : Date      Reason                                               *
 *           00/00/00  Created                                              *
 *                                                                          *
 ****************************************************************************/

static INT_PTR CALLBACK MainDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	RECT rt;

    switch (uMsg)
    {
        case WM_INITDIALOG:
            /*
             * TODO: Add code to initialize the dialog.
             */
            return TRUE;

		case WM_MOUSEMOVE:
			xmouse = LOWORD(lParam);
			ymouse = HIWORD(lParam);

			GetClientRect(hwndDlg, &rt);
			InvalidateRect(hwndDlg, &rt, FALSE);
			return TRUE;

		case WM_PAINT:
			hdc = BeginPaint(hwndDlg, &ps);
			Rectangle(hdc, 0,0, rt.right, rt.bottom);
			fn_main(hdc);
			ReleaseDC(hwndDlg, hdc);
			return TRUE;

        case WM_SIZE:
            /*
             * TODO: Add code to process resizing, when needed.
             */
            return TRUE;

        case WM_COMMAND:
            switch (GET_WM_COMMAND_ID(wParam, lParam))
            {
                /*
                 * TODO: Add more control ID's, when needed.
                 */
                case IDOK:
                    EndDialog(hwndDlg, TRUE);
                    return TRUE;
            }
            break;

        case WM_CLOSE:
            EndDialog(hwndDlg, 0);
            return TRUE;

        /*
         * TODO: Add more messages, when needed.
         */
    }

    return FALSE;
}
